﻿/******************************************************************************
 * SunnyUI 开源控件库、工具类库、扩展类库、多页面开发框架。
 * CopyRight (C) 2012-2021 ShenYongHua(沈永华).
 * QQ群：56829229 QQ：17612584 EMail：SunnyUI@QQ.Com
 *
 * Blog:   https://www.cnblogs.com/yhuse
 * Gitee:  https://gitee.com/yhuse/SunnyUI
 * GitHub: https://github.com/yhuse/SunnyUI
 *
 * SunnyUI.dll can be used for free under the GPL-3.0 license.
 * If you use this code, please keep this note.
 * 如果您使用此代码，请保留此说明。
 ******************************************************************************
 * 文件名称: UFontAweSome.cs
 * 文件说明: 字体图片定义类：FontAweSome，V4.7.0
 * 当前版本: V3.0
 * 创建日期: 2020-02-26
 *
 * 2020-02-26: V3.0.2 增加文件说明
******************************************************************************/

/******************************************************************************
 * https://fontawesome.com/icons?d=listing&p=2&m=free
 ******************************************************************************
 
Font Awesome Free License
-------------------------

Font Awesome Free is free, open source, and GPL friendly. You can use it for
commercial projects, open source projects, or really almost whatever you want.
Full Font Awesome Free license: https://fontawesome.com/license/free.

# Icons: CC BY 4.0 License (https://creativecommons.org/licenses/by/4.0/)
In the Font Awesome Free download, the CC BY 4.0 license applies to all icons
packaged as SVG and JS file types.

# Fonts: SIL OFL 1.1 License (https://scripts.sil.org/OFL)
In the Font Awesome Free download, the SIL OFL license applies to all icons
packaged as web and desktop font files.

# Code: MIT License (https://opensource.org/licenses/MIT)
In the Font Awesome Free download, the MIT license applies to all non-font and
non-icon files.

# Attribution
Attribution is required by MIT, SIL OFL, and CC BY licenses. Downloaded Font
Awesome Free files already contain embedded comments with sufficient
attribution, so you shouldn't need to do anything additional when using these
files normally.

We've kept attribution comments terse, so we ask that you do not actively work
to remove them from files, especially code. They're a great way for folks to
learn about Font Awesome.

# Brand Icons
All brand icons are trademarks of their respective owners. The use of these
trademarks does not indicate endorsement of the trademark holder by Font
Awesome, nor vice versa. **Please do not use brand logos for any purpose except
to represent the company, product, or service to which they refer.

******************************************************************************/

namespace Sunny.UI
{
    /// <summary>
    /// FontAwesome.ttf V4.7
    /// 61440..62176
    /// </summary>
    public static class FontAwesomeIcons
    {
        public const int fa_500px = 0xf26e;

        public const int fa_address_book = 0xf2b9;
        public const int fa_address_book_o = 0xf2ba;
        public const int fa_address_card = 0xf2bb;
        public const int fa_address_card_o = 0xf2bc;
        public const int fa_adjust = 0xf042;
        public const int fa_adn = 0xf170;
        public const int fa_align_center = 0xf037;
        public const int fa_align_justify = 0xf039;
        public const int fa_align_left = 0xf036;
        public const int fa_align_right = 0xf038;
        public const int fa_amazon = 0xf270;
        public const int fa_ambulance = 0xf0f9;
        public const int fa_american_sign_language_interpreting = 0xf2a3;
        public const int fa_anchor = 0xf13d;
        public const int fa_android = 0xf17b;
        public const int fa_angellist = 0xf209;
        public const int fa_angle_double_down = 0xf103;
        public const int fa_angle_double_left = 0xf100;
        public const int fa_angle_double_right = 0xf101;
        public const int fa_angle_double_up = 0xf102;
        public const int fa_angle_down = 0xf107;
        public const int fa_angle_left = 0xf104;
        public const int fa_angle_right = 0xf105;
        public const int fa_angle_up = 0xf106;
        public const int fa_apple = 0xf179;
        public const int fa_archive = 0xf187;
        public const int fa_area_chart = 0xf1fe;
        public const int fa_arrow_circle_down = 0xf0ab;
        public const int fa_arrow_circle_left = 0xf0a8;
        public const int fa_arrow_circle_o_down = 0xf01a;
        public const int fa_arrow_circle_o_left = 0xf190;
        public const int fa_arrow_circle_o_right = 0xf18e;
        public const int fa_arrow_circle_o_up = 0xf01b;
        public const int fa_arrow_circle_right = 0xf0a9;
        public const int fa_arrow_circle_up = 0xf0aa;
        public const int fa_arrow_down = 0xf063;
        public const int fa_arrow_left = 0xf060;
        public const int fa_arrow_right = 0xf061;
        public const int fa_arrow_up = 0xf062;
        public const int fa_arrows = 0xf047;
        public const int fa_arrows_alt = 0xf0b2;
        public const int fa_arrows_h = 0xf07e;
        public const int fa_arrows_v = 0xf07d;
        public const int fa_asl_interpreting = 0xf2a3;
        public const int fa_assistive_listening_systems = 0xf2a2;
        public const int fa_asterisk = 0xf069;
        public const int fa_at = 0xf1fa;
        public const int fa_audio_description = 0xf29e;
        public const int fa_automobile = 0xf1b9;

        public const int fa_backward = 0xf04a;
        public const int fa_balance_scale = 0xf24e;
        public const int fa_ban = 0xf05e;
        public const int fa_bandcamp = 0xf2d5;
        public const int fa_bank = 0xf19c;
        public const int fa_bar_chart = 0xf080;
        public const int fa_bar_chart_o = 0xf080;
        public const int fa_barcode = 0xf02a;
        public const int fa_bars = 0xf0c9;
        public const int fa_bath = 0xf2cd;
        public const int fa_bathtub = 0xf2cd;
        public const int fa_battery = 0xf240;
        public const int fa_battery_0 = 0xf244;
        public const int fa_battery_1 = 0xf243;
        public const int fa_battery_2 = 0xf242;
        public const int fa_battery_3 = 0xf241;
        public const int fa_battery_4 = 0xf240;
        public const int fa_battery_empty = 0xf244;
        public const int fa_battery_full = 0xf240;
        public const int fa_battery_half = 0xf242;
        public const int fa_battery_quarter = 0xf243;
        public const int fa_battery_three_quarters = 0xf241;
        public const int fa_bed = 0xf236;
        public const int fa_beer = 0xf0fc;
        public const int fa_behance = 0xf1b4;
        public const int fa_behance_square = 0xf1b5;
        public const int fa_bell = 0xf0f3;
        public const int fa_bell_o = 0xf0a2;
        public const int fa_bell_slash = 0xf1f6;
        public const int fa_bell_slash_o = 0xf1f7;
        public const int fa_bicycle = 0xf206;
        public const int fa_binoculars = 0xf1e5;
        public const int fa_birthday_cake = 0xf1fd;
        public const int fa_bitbucket = 0xf171;
        public const int fa_bitbucket_square = 0xf172;
        public const int fa_bitcoin = 0xf15a;
        public const int fa_black_tie = 0xf27e;
        public const int fa_blind = 0xf29d;
        public const int fa_bluetooth = 0xf293;
        public const int fa_bluetooth_b = 0xf294;
        public const int fa_bold = 0xf032;
        public const int fa_bolt = 0xf0e7;
        public const int fa_bomb = 0xf1e2;
        public const int fa_book = 0xf02d;
        public const int fa_bookmark = 0xf02e;
        public const int fa_bookmark_o = 0xf097;
        public const int fa_braille = 0xf2a1;
        public const int fa_briefcase = 0xf0b1;
        public const int fa_btc = 0xf15a;
        public const int fa_bug = 0xf188;
        public const int fa_building = 0xf1ad;
        public const int fa_building_o = 0xf0f7;
        public const int fa_bullhorn = 0xf0a1;
        public const int fa_bullseye = 0xf140;
        public const int fa_bus = 0xf207;
        public const int fa_buysellads = 0xf20d;

        public const int fa_cab = 0xf1ba;
        public const int fa_calculator = 0xf1ec;
        public const int fa_calendar = 0xf073;
        public const int fa_calendar_check_o = 0xf274;
        public const int fa_calendar_minus_o = 0xf272;
        public const int fa_calendar_o = 0xf133;
        public const int fa_calendar_plus_o = 0xf271;
        public const int fa_calendar_times_o = 0xf273;
        public const int fa_camera = 0xf030;
        public const int fa_camera_retro = 0xf083;
        public const int fa_car = 0xf1b9;
        public const int fa_caret_down = 0xf0d7;
        public const int fa_caret_left = 0xf0d9;
        public const int fa_caret_right = 0xf0da;
        public const int fa_caret_square_o_down = 0xf150;
        public const int fa_caret_square_o_left = 0xf191;
        public const int fa_caret_square_o_right = 0xf152;
        public const int fa_caret_square_o_up = 0xf151;
        public const int fa_caret_up = 0xf0d8;
        public const int fa_cart_arrow_down = 0xf218;
        public const int fa_cart_plus = 0xf217;
        public const int fa_cc = 0xf20a;
        public const int fa_cc_amex = 0xf1f3;
        public const int fa_cc_diners_club = 0xf24c;
        public const int fa_cc_discover = 0xf1f2;
        public const int fa_cc_jcb = 0xf24b;
        public const int fa_cc_mastercard = 0xf1f1;
        public const int fa_cc_paypal = 0xf1f4;
        public const int fa_cc_stripe = 0xf1f5;
        public const int fa_cc_visa = 0xf1f0;
        public const int fa_certificate = 0xf0a3;
        public const int fa_chain = 0xf0c1;
        public const int fa_chain_broken = 0xf127;
        public const int fa_check = 0xf00c;
        public const int fa_check_circle = 0xf058;
        public const int fa_check_circle_o = 0xf05d;
        public const int fa_check_square = 0xf14a;
        public const int fa_check_square_o = 0xf046;
        public const int fa_chevron_circle_down = 0xf13a;
        public const int fa_chevron_circle_left = 0xf137;
        public const int fa_chevron_circle_right = 0xf138;
        public const int fa_chevron_circle_up = 0xf139;
        public const int fa_chevron_down = 0xf078;
        public const int fa_chevron_left = 0xf053;
        public const int fa_chevron_right = 0xf054;
        public const int fa_chevron_up = 0xf077;
        public const int fa_child = 0xf1ae;
        public const int fa_chrome = 0xf268;
        public const int fa_circle = 0xf111;
        public const int fa_circle_o = 0xf10c;
        public const int fa_circle_o_notch = 0xf1ce;
        public const int fa_circle_thin = 0xf1db;
        public const int fa_clipboard = 0xf0ea;
        public const int fa_clock_o = 0xf017;
        public const int fa_clone = 0xf24d;
        public const int fa_close = 0xf00d;
        public const int fa_cloud = 0xf0c2;
        public const int fa_cloud_download = 0xf0ed;
        public const int fa_cloud_upload = 0xf0ee;
        public const int fa_cny = 0xf157;
        public const int fa_code = 0xf121;
        public const int fa_code_fork = 0xf126;
        public const int fa_codepen = 0xf1cb;
        public const int fa_codiepie = 0xf284;
        public const int fa_coffee = 0xf0f4;
        public const int fa_cog = 0xf013;
        public const int fa_cogs = 0xf085;
        public const int fa_columns = 0xf0db;
        public const int fa_comment = 0xf075;
        public const int fa_comment_o = 0xf0e5;
        public const int fa_commenting = 0xf27a;
        public const int fa_commenting_o = 0xf27b;
        public const int fa_comments = 0xf086;
        public const int fa_comments_o = 0xf0e6;
        public const int fa_compass = 0xf14e;
        public const int fa_compress = 0xf066;
        public const int fa_connectdevelop = 0xf20e;
        public const int fa_contao = 0xf26d;
        public const int fa_copy = 0xf0c5;
        public const int fa_copyright = 0xf1f9;
        public const int fa_creative_commons = 0xf25e;
        public const int fa_credit_card = 0xf09d;
        public const int fa_credit_card_alt = 0xf283;
        public const int fa_crop = 0xf125;
        public const int fa_crosshairs = 0xf05b;
        public const int fa_css3 = 0xf13c;
        public const int fa_cube = 0xf1b2;
        public const int fa_cubes = 0xf1b3;
        public const int fa_cut = 0xf0c4;
        public const int fa_cutlery = 0xf0f5;

        public const int fa_dashboard = 0xf0e4;
        public const int fa_dashcube = 0xf210;
        public const int fa_database = 0xf1c0;
        public const int fa_deaf = 0xf2a4;
        public const int fa_deafness = 0xf2a4;
        public const int fa_dedent = 0xf03b;
        public const int fa_delicious = 0xf1a5;
        public const int fa_desktop = 0xf108;
        public const int fa_deviantart = 0xf1bd;
        public const int fa_diamond = 0xf219;
        public const int fa_digg = 0xf1a6;
        public const int fa_dollar = 0xf155;
        public const int fa_dot_circle_o = 0xf192;
        public const int fa_download = 0xf019;
        public const int fa_dribbble = 0xf17d;
        public const int fa_drivers_license = 0xf2c2;
        public const int fa_drivers_license_o = 0xf2c3;
        public const int fa_dropbox = 0xf16b;
        public const int fa_drupal = 0xf1a9;

        public const int fa_edge = 0xf282;
        public const int fa_edit = 0xf044;
        public const int fa_eercast = 0xf2da;
        public const int fa_eject = 0xf052;
        public const int fa_ellipsis_h = 0xf141;
        public const int fa_ellipsis_v = 0xf142;
        public const int fa_empire = 0xf1d1;
        public const int fa_envelope = 0xf0e0;
        public const int fa_envelope_o = 0xf003;
        public const int fa_envelope_open = 0xf2b6;
        public const int fa_envelope_open_o = 0xf2b7;
        public const int fa_envelope_square = 0xf199;
        public const int fa_envira = 0xf299;
        public const int fa_eraser = 0xf12d;
        public const int fa_etsy = 0xf2d7;
        public const int fa_eur = 0xf153;
        public const int fa_euro = 0xf153;
        public const int fa_exchange = 0xf0ec;
        public const int fa_exclamation = 0xf12a;
        public const int fa_exclamation_circle = 0xf06a;
        public const int fa_exclamation_triangle = 0xf071;
        public const int fa_expand = 0xf065;
        public const int fa_expeditedssl = 0xf23e;
        public const int fa_external_link = 0xf08e;
        public const int fa_external_link_square = 0xf14c;
        public const int fa_eye = 0xf06e;
        public const int fa_eye_slash = 0xf070;
        public const int fa_eyedropper = 0xf1fb;

        public const int fa_fa = 0xf2b4;
        public const int fa_facebook = 0xf09a;
        public const int fa_facebook_f = 0xf09a;
        public const int fa_facebook_official = 0xf230;
        public const int fa_facebook_square = 0xf082;
        public const int fa_fast_backward = 0xf049;
        public const int fa_fast_forward = 0xf050;
        public const int fa_fax = 0xf1ac;
        public const int fa_feed = 0xf09e;
        public const int fa_female = 0xf182;
        public const int fa_fighter_jet = 0xf0fb;
        public const int fa_file = 0xf15b;
        public const int fa_file_archive_o = 0xf1c6;
        public const int fa_file_audio_o = 0xf1c7;
        public const int fa_file_code_o = 0xf1c9;
        public const int fa_file_excel_o = 0xf1c3;
        public const int fa_file_image_o = 0xf1c5;
        public const int fa_file_movie_o = 0xf1c8;
        public const int fa_file_o = 0xf016;
        public const int fa_file_pdf_o = 0xf1c1;
        public const int fa_file_photo_o = 0xf1c5;
        public const int fa_file_picture_o = 0xf1c5;
        public const int fa_file_powerpoint_o = 0xf1c4;
        public const int fa_file_sound_o = 0xf1c7;
        public const int fa_file_text = 0xf15c;
        public const int fa_file_text_o = 0xf0f6;
        public const int fa_file_video_o = 0xf1c8;
        public const int fa_file_word_o = 0xf1c2;
        public const int fa_file_zip_o = 0xf1c6;
        public const int fa_files_o = 0xf0c5;
        public const int fa_film = 0xf008;
        public const int fa_filter = 0xf0b0;
        public const int fa_fire = 0xf06d;
        public const int fa_fire_extinguisher = 0xf134;
        public const int fa_firefox = 0xf269;
        public const int fa_first_order = 0xf2b0;
        public const int fa_flag = 0xf024;
        public const int fa_flag_checkered = 0xf11e;
        public const int fa_flag_o = 0xf11d;
        public const int fa_flash = 0xf0e7;
        public const int fa_flask = 0xf0c3;
        public const int fa_flickr = 0xf16e;
        public const int fa_floppy_o = 0xf0c7;
        public const int fa_folder = 0xf07b;
        public const int fa_folder_o = 0xf114;
        public const int fa_folder_open = 0xf07c;
        public const int fa_folder_open_o = 0xf115;
        public const int fa_font = 0xf031;
        public const int fa_font_awesome = 0xf2b4;
        public const int fa_fonticons = 0xf280;
        public const int fa_fort_awesome = 0xf286;
        public const int fa_forumbee = 0xf211;
        public const int fa_forward = 0xf04e;
        public const int fa_foursquare = 0xf180;
        public const int fa_free_code_camp = 0xf2c5;
        public const int fa_frown_o = 0xf119;
        public const int fa_futbol_o = 0xf1e3;

        public const int fa_gamepad = 0xf11b;
        public const int fa_gavel = 0xf0e3;
        public const int fa_gbp = 0xf154;
        public const int fa_ge = 0xf1d1;
        public const int fa_gear = 0xf013;
        public const int fa_gears = 0xf085;
        public const int fa_genderless = 0xf22d;
        public const int fa_get_pocket = 0xf265;
        public const int fa_gg = 0xf260;
        public const int fa_gg_circle = 0xf261;
        public const int fa_gift = 0xf06b;
        public const int fa_git = 0xf1d3;
        public const int fa_git_square = 0xf1d2;
        public const int fa_github = 0xf09b;
        public const int fa_github_alt = 0xf113;
        public const int fa_github_square = 0xf092;
        public const int fa_gitlab = 0xf296;
        public const int fa_gittip = 0xf184;
        public const int fa_glass = 0xf000;
        public const int fa_glide = 0xf2a5;
        public const int fa_glide_g = 0xf2a6;
        public const int fa_globe = 0xf0ac;
        public const int fa_google = 0xf1a0;
        public const int fa_google_plus = 0xf0d5;
        public const int fa_google_plus_circle = 0xf2b3;
        public const int fa_google_plus_official = 0xf2b3;
        public const int fa_google_plus_square = 0xf0d4;
        public const int fa_google_wallet = 0xf1ee;
        public const int fa_graduation_cap = 0xf19d;
        public const int fa_gratipay = 0xf184;
        public const int fa_grav = 0xf2d6;
        public const int fa_group = 0xf0c0;

        public const int fa_h_square = 0xf0fd;
        public const int fa_hacker_news = 0xf1d4;
        public const int fa_hand_grab_o = 0xf255;
        public const int fa_hand_lizard_o = 0xf258;
        public const int fa_hand_o_down = 0xf0a7;
        public const int fa_hand_o_left = 0xf0a5;
        public const int fa_hand_o_right = 0xf0a4;
        public const int fa_hand_o_up = 0xf0a6;
        public const int fa_hand_paper_o = 0xf256;
        public const int fa_hand_peace_o = 0xf25b;
        public const int fa_hand_pointer_o = 0xf25a;
        public const int fa_hand_rock_o = 0xf255;
        public const int fa_hand_scissors_o = 0xf257;
        public const int fa_hand_spock_o = 0xf259;
        public const int fa_hand_stop_o = 0xf256;
        public const int fa_handshake_o = 0xf2b5;
        public const int fa_hard_of_hearing = 0xf2a4;
        public const int fa_hashtag = 0xf292;
        public const int fa_hdd_o = 0xf0a0;
        public const int fa_header = 0xf1dc;
        public const int fa_headphones = 0xf025;
        public const int fa_heart = 0xf004;
        public const int fa_heart_o = 0xf08a;
        public const int fa_heartbeat = 0xf21e;
        public const int fa_history = 0xf1da;
        public const int fa_home = 0xf015;
        public const int fa_hospital_o = 0xf0f8;
        public const int fa_hotel = 0xf236;
        public const int fa_hourglass = 0xf254;
        public const int fa_hourglass_1 = 0xf251;
        public const int fa_hourglass_2 = 0xf252;
        public const int fa_hourglass_3 = 0xf253;
        public const int fa_hourglass_end = 0xf253;
        public const int fa_hourglass_half = 0xf252;
        public const int fa_hourglass_o = 0xf250;
        public const int fa_hourglass_start = 0xf251;
        public const int fa_houzz = 0xf27c;
        public const int fa_html5 = 0xf13b;

        public const int fa_i_cursor = 0xf246;
        public const int fa_id_badge = 0xf2c1;
        public const int fa_id_card = 0xf2c2;
        public const int fa_id_card_o = 0xf2c3;
        public const int fa_ils = 0xf20b;
        public const int fa_image = 0xf03e;
        public const int fa_imdb = 0xf2d8;
        public const int fa_inbox = 0xf01c;
        public const int fa_indent = 0xf03c;
        public const int fa_industry = 0xf275;
        public const int fa_info = 0xf129;
        public const int fa_info_circle = 0xf05a;
        public const int fa_inr = 0xf156;
        public const int fa_instagram = 0xf16d;
        public const int fa_institution = 0xf19c;
        public const int fa_internet_explorer = 0xf26b;
        public const int fa_intersex = 0xf224;
        public const int fa_ioxhost = 0xf208;
        public const int fa_italic = 0xf033;

        public const int fa_joomla = 0xf1aa;
        public const int fa_jpy = 0xf157;
        public const int fa_jsfiddle = 0xf1cc;

        public const int fa_key = 0xf084;
        public const int fa_keyboard_o = 0xf11c;
        public const int fa_krw = 0xf159;

        public const int fa_language = 0xf1ab;
        public const int fa_laptop = 0xf109;
        public const int fa_lastfm = 0xf202;
        public const int fa_lastfm_square = 0xf203;
        public const int fa_leaf = 0xf06c;
        public const int fa_leanpub = 0xf212;
        public const int fa_legal = 0xf0e3;
        public const int fa_lemon_o = 0xf094;
        public const int fa_level_down = 0xf149;
        public const int fa_level_up = 0xf148;
        public const int fa_life_bouy = 0xf1cd;
        public const int fa_life_buoy = 0xf1cd;
        public const int fa_life_ring = 0xf1cd;
        public const int fa_life_saver = 0xf1cd;
        public const int fa_lightbulb_o = 0xf0eb;
        public const int fa_line_chart = 0xf201;
        public const int fa_link = 0xf0c1;
        public const int fa_linkedin = 0xf0e1;
        public const int fa_linkedin_square = 0xf08c;
        public const int fa_linode = 0xf2b8;
        public const int fa_linux = 0xf17c;
        public const int fa_list = 0xf03a;
        public const int fa_list_alt = 0xf022;
        public const int fa_list_ol = 0xf0cb;
        public const int fa_list_ul = 0xf0ca;
        public const int fa_location_arrow = 0xf124;
        public const int fa_lock = 0xf023;
        public const int fa_long_arrow_down = 0xf175;
        public const int fa_long_arrow_left = 0xf177;
        public const int fa_long_arrow_right = 0xf178;
        public const int fa_long_arrow_up = 0xf176;
        public const int fa_low_vision = 0xf2a8;

        public const int fa_magic = 0xf0d0;
        public const int fa_magnet = 0xf076;
        public const int fa_mail_forward = 0xf064;
        public const int fa_mail_reply = 0xf112;
        public const int fa_mail_reply_all = 0xf122;
        public const int fa_male = 0xf183;
        public const int fa_map = 0xf279;
        public const int fa_map_marker = 0xf041;
        public const int fa_map_o = 0xf278;
        public const int fa_map_pin = 0xf276;
        public const int fa_map_signs = 0xf277;
        public const int fa_mars = 0xf222;
        public const int fa_mars_double = 0xf227;
        public const int fa_mars_stroke = 0xf229;
        public const int fa_mars_stroke_h = 0xf22b;
        public const int fa_mars_stroke_v = 0xf22a;
        public const int fa_maxcdn = 0xf136;
        public const int fa_meanpath = 0xf20c;
        public const int fa_medium = 0xf23a;
        public const int fa_medkit = 0xf0fa;
        public const int fa_meetup = 0xf2e0;
        public const int fa_meh_o = 0xf11a;
        public const int fa_mercury = 0xf223;
        public const int fa_microchip = 0xf2db;
        public const int fa_microphone = 0xf130;
        public const int fa_microphone_slash = 0xf131;
        public const int fa_minus = 0xf068;
        public const int fa_minus_circle = 0xf056;
        public const int fa_minus_square = 0xf146;
        public const int fa_minus_square_o = 0xf147;
        public const int fa_mixcloud = 0xf289;
        public const int fa_mobile = 0xf10b;
        public const int fa_mobile_phone = 0xf10b;
        public const int fa_modx = 0xf285;
        public const int fa_money = 0xf0d6;
        public const int fa_moon_o = 0xf186;
        public const int fa_mortar_board = 0xf19d;
        public const int fa_motorcycle = 0xf21c;
        public const int fa_mouse_pointer = 0xf245;
        public const int fa_music = 0xf001;

        public const int fa_navicon = 0xf0c9;
        public const int fa_neuter = 0xf22c;
        public const int fa_newspaper_o = 0xf1ea;

        public const int fa_object_group = 0xf247;
        public const int fa_object_ungroup = 0xf248;
        public const int fa_odnoklassniki = 0xf263;
        public const int fa_odnoklassniki_square = 0xf264;
        public const int fa_opencart = 0xf23d;
        public const int fa_openid = 0xf19b;
        public const int fa_opera = 0xf26a;
        public const int fa_optin_monster = 0xf23c;
        public const int fa_outdent = 0xf03b;

        public const int fa_pagelines = 0xf18c;
        public const int fa_paint_brush = 0xf1fc;
        public const int fa_paper_plane = 0xf1d8;
        public const int fa_paper_plane_o = 0xf1d9;
        public const int fa_paperclip = 0xf0c6;
        public const int fa_paragraph = 0xf1dd;
        public const int fa_paste = 0xf0ea;
        public const int fa_pause = 0xf04c;
        public const int fa_pause_circle = 0xf28b;
        public const int fa_pause_circle_o = 0xf28c;
        public const int fa_paw = 0xf1b0;
        public const int fa_paypal = 0xf1ed;
        public const int fa_pencil = 0xf040;
        public const int fa_pencil_square = 0xf14b;
        public const int fa_pencil_square_o = 0xf044;
        public const int fa_percent = 0xf295;
        public const int fa_phone = 0xf095;
        public const int fa_phone_square = 0xf098;
        public const int fa_photo = 0xf03e;
        public const int fa_picture_o = 0xf03e;
        public const int fa_pie_chart = 0xf200;
        public const int fa_pied_piper = 0xf2ae;
        public const int fa_pied_piper_alt = 0xf1a8;
        public const int fa_pied_piper_pp = 0xf1a7;
        public const int fa_pinterest = 0xf0d2;
        public const int fa_pinterest_p = 0xf231;
        public const int fa_pinterest_square = 0xf0d3;
        public const int fa_plane = 0xf072;
        public const int fa_play = 0xf04b;
        public const int fa_play_circle = 0xf144;
        public const int fa_play_circle_o = 0xf01d;
        public const int fa_plug = 0xf1e6;
        public const int fa_plus = 0xf067;
        public const int fa_plus_circle = 0xf055;
        public const int fa_plus_square = 0xf0fe;
        public const int fa_plus_square_o = 0xf196;
        public const int fa_podcast = 0xf2ce;
        public const int fa_power_off = 0xf011;
        public const int fa_print = 0xf02f;
        public const int fa_product_hunt = 0xf288;
        public const int fa_puzzle_piece = 0xf12e;

        public const int fa_qq = 0xf1d6;
        public const int fa_qrcode = 0xf029;
        public const int fa_question = 0xf128;
        public const int fa_question_circle = 0xf059;
        public const int fa_question_circle_o = 0xf29c;
        public const int fa_quora = 0xf2c4;
        public const int fa_quote_left = 0xf10d;
        public const int fa_quote_right = 0xf10e;

        public const int fa_ra = 0xf1d0;
        public const int fa_random = 0xf074;
        public const int fa_ravelry = 0xf2d9;
        public const int fa_rebel = 0xf1d0;
        public const int fa_recycle = 0xf1b8;
        public const int fa_reddit = 0xf1a1;
        public const int fa_reddit_alien = 0xf281;
        public const int fa_reddit_square = 0xf1a2;
        public const int fa_refresh = 0xf021;
        public const int fa_registered = 0xf25d;
        public const int fa_remove = 0xf00d;
        public const int fa_renren = 0xf18b;
        public const int fa_reorder = 0xf0c9;
        public const int fa_repeat = 0xf01e;
        public const int fa_reply = 0xf112;
        public const int fa_reply_all = 0xf122;
        public const int fa_resistance = 0xf1d0;
        public const int fa_retweet = 0xf079;
        public const int fa_rmb = 0xf157;
        public const int fa_road = 0xf018;
        public const int fa_rocket = 0xf135;
        public const int fa_rotate_left = 0xf0e2;
        public const int fa_rotate_right = 0xf01e;
        public const int fa_rouble = 0xf158;
        public const int fa_rss = 0xf09e;
        public const int fa_rss_square = 0xf143;
        public const int fa_rub = 0xf158;
        public const int fa_ruble = 0xf158;
        public const int fa_rupee = 0xf156;

        public const int fa_s15 = 0xf2cd;
        public const int fa_safari = 0xf267;
        public const int fa_save = 0xf0c7;
        public const int fa_scissors = 0xf0c4;
        public const int fa_scribd = 0xf28a;
        public const int fa_search = 0xf002;
        public const int fa_search_minus = 0xf010;
        public const int fa_search_plus = 0xf00e;
        public const int fa_sellsy = 0xf213;
        public const int fa_send = 0xf1d8;
        public const int fa_send_o = 0xf1d9;
        public const int fa_server = 0xf233;
        public const int fa_share = 0xf064;
        public const int fa_share_alt = 0xf1e0;
        public const int fa_share_alt_square = 0xf1e1;
        public const int fa_share_square = 0xf14d;
        public const int fa_share_square_o = 0xf045;
        public const int fa_shekel = 0xf20b;
        public const int fa_sheqel = 0xf20b;
        public const int fa_shield = 0xf132;
        public const int fa_ship = 0xf21a;
        public const int fa_shirtsinbulk = 0xf214;
        public const int fa_shopping_bag = 0xf290;
        public const int fa_shopping_basket = 0xf291;
        public const int fa_shopping_cart = 0xf07a;
        public const int fa_shower = 0xf2cc;
        public const int fa_sign_in = 0xf090;
        public const int fa_sign_language = 0xf2a7;
        public const int fa_sign_out = 0xf08b;
        public const int fa_signal = 0xf012;
        public const int fa_signing = 0xf2a7;
        public const int fa_simplybuilt = 0xf215;
        public const int fa_sitemap = 0xf0e8;
        public const int fa_skyatlas = 0xf216;
        public const int fa_skype = 0xf17e;
        public const int fa_slack = 0xf198;
        public const int fa_sliders = 0xf1de;
        public const int fa_slideshare = 0xf1e7;
        public const int fa_smile_o = 0xf118;
        public const int fa_snapchat = 0xf2ab;
        public const int fa_snapchat_ghost = 0xf2ac;
        public const int fa_snapchat_square = 0xf2ad;
        public const int fa_snowflake_o = 0xf2dc;
        public const int fa_soccer_ball_o = 0xf1e3;
        public const int fa_sort = 0xf0dc;
        public const int fa_sort_alpha_asc = 0xf15d;
        public const int fa_sort_alpha_desc = 0xf15e;
        public const int fa_sort_amount_asc = 0xf160;
        public const int fa_sort_amount_desc = 0xf161;
        public const int fa_sort_asc = 0xf0de;
        public const int fa_sort_desc = 0xf0dd;
        public const int fa_sort_down = 0xf0dd;
        public const int fa_sort_numeric_asc = 0xf162;
        public const int fa_sort_numeric_desc = 0xf163;
        public const int fa_sort_up = 0xf0de;
        public const int fa_soundcloud = 0xf1be;
        public const int fa_space_shuttle = 0xf197;
        public const int fa_spinner = 0xf110;
        public const int fa_spoon = 0xf1b1;
        public const int fa_spotify = 0xf1bc;
        public const int fa_square = 0xf0c8;
        public const int fa_square_o = 0xf096;
        public const int fa_stack_exchange = 0xf18d;
        public const int fa_stack_overflow = 0xf16c;
        public const int fa_star = 0xf005;
        public const int fa_star_half = 0xf089;
        public const int fa_star_half_empty = 0xf123;
        public const int fa_star_half_full = 0xf123;
        public const int fa_star_half_o = 0xf123;
        public const int fa_star_o = 0xf006;
        public const int fa_steam = 0xf1b6;
        public const int fa_steam_square = 0xf1b7;
        public const int fa_step_backward = 0xf048;
        public const int fa_step_forward = 0xf051;
        public const int fa_stethoscope = 0xf0f1;
        public const int fa_sticky_note = 0xf249;
        public const int fa_sticky_note_o = 0xf24a;
        public const int fa_stop = 0xf04d;
        public const int fa_stop_circle = 0xf28d;
        public const int fa_stop_circle_o = 0xf28e;
        public const int fa_street_view = 0xf21d;
        public const int fa_strikethrough = 0xf0cc;
        public const int fa_stumbleupon = 0xf1a4;
        public const int fa_stumbleupon_circle = 0xf1a3;
        public const int fa_subscript = 0xf12c;
        public const int fa_subway = 0xf239;
        public const int fa_suitcase = 0xf0f2;
        public const int fa_sun_o = 0xf185;
        public const int fa_superpowers = 0xf2dd;
        public const int fa_superscript = 0xf12b;
        public const int fa_support = 0xf1cd;

        public const int fa_table = 0xf0ce;
        public const int fa_tablet = 0xf10a;
        public const int fa_tachometer = 0xf0e4;
        public const int fa_tag = 0xf02b;
        public const int fa_tags = 0xf02c;
        public const int fa_tasks = 0xf0ae;
        public const int fa_taxi = 0xf1ba;
        public const int fa_telegram = 0xf2c6;
        public const int fa_television = 0xf26c;
        public const int fa_tencent_weibo = 0xf1d5;
        public const int fa_terminal = 0xf120;
        public const int fa_text_height = 0xf034;
        public const int fa_text_width = 0xf035;
        public const int fa_th = 0xf00a;
        public const int fa_th_large = 0xf009;
        public const int fa_th_list = 0xf00b;
        public const int fa_themeisle = 0xf2b2;
        public const int fa_thermometer = 0xf2c7;
        public const int fa_thermometer_0 = 0xf2cb;
        public const int fa_thermometer_1 = 0xf2ca;
        public const int fa_thermometer_2 = 0xf2c9;
        public const int fa_thermometer_3 = 0xf2c8;
        public const int fa_thermometer_4 = 0xf2c7;
        public const int fa_thermometer_empty = 0xf2cb;
        public const int fa_thermometer_full = 0xf2c7;
        public const int fa_thermometer_half = 0xf2c9;
        public const int fa_thermometer_quarter = 0xf2ca;
        public const int fa_thermometer_three_quarters = 0xf2c8;
        public const int fa_thumb_tack = 0xf08d;
        public const int fa_thumbs_down = 0xf165;
        public const int fa_thumbs_o_down = 0xf088;
        public const int fa_thumbs_o_up = 0xf087;
        public const int fa_thumbs_up = 0xf164;
        public const int fa_ticket = 0xf145;
        public const int fa_times = 0xf00d;
        public const int fa_times_circle = 0xf057;
        public const int fa_times_circle_o = 0xf05c;
        public const int fa_times_rectangle = 0xf2d3;
        public const int fa_times_rectangle_o = 0xf2d4;
        public const int fa_tint = 0xf043;
        public const int fa_toggle_down = 0xf150;
        public const int fa_toggle_left = 0xf191;
        public const int fa_toggle_off = 0xf204;
        public const int fa_toggle_on = 0xf205;
        public const int fa_toggle_right = 0xf152;
        public const int fa_toggle_up = 0xf151;
        public const int fa_trademark = 0xf25c;
        public const int fa_train = 0xf238;
        public const int fa_transgender = 0xf224;
        public const int fa_transgender_alt = 0xf225;
        public const int fa_trash = 0xf1f8;
        public const int fa_trash_o = 0xf014;
        public const int fa_tree = 0xf1bb;
        public const int fa_trello = 0xf181;
        public const int fa_tripadvisor = 0xf262;
        public const int fa_trophy = 0xf091;
        public const int fa_truck = 0xf0d1;
        public const int fa_try = 0xf195;
        public const int fa_tty = 0xf1e4;
        public const int fa_tumblr = 0xf173;
        public const int fa_tumblr_square = 0xf174;
        public const int fa_turkish_lira = 0xf195;
        public const int fa_tv = 0xf26c;
        public const int fa_twitch = 0xf1e8;
        public const int fa_twitter = 0xf099;
        public const int fa_twitter_square = 0xf081;

        public const int fa_umbrella = 0xf0e9;
        public const int fa_underline = 0xf0cd;
        public const int fa_undo = 0xf0e2;
        public const int fa_universal_access = 0xf29a;
        public const int fa_university = 0xf19c;
        public const int fa_unlink = 0xf127;
        public const int fa_unlock = 0xf09c;
        public const int fa_unlock_alt = 0xf13e;
        public const int fa_unsorted = 0xf0dc;
        public const int fa_upload = 0xf093;
        public const int fa_usb = 0xf287;
        public const int fa_usd = 0xf155;
        public const int fa_user = 0xf007;
        public const int fa_user_circle = 0xf2bd;
        public const int fa_user_circle_o = 0xf2be;
        public const int fa_user_md = 0xf0f0;
        public const int fa_user_o = 0xf2c0;
        public const int fa_user_plus = 0xf234;
        public const int fa_user_secret = 0xf21b;
        public const int fa_user_times = 0xf235;
        public const int fa_users = 0xf0c0;

        public const int fa_vcard = 0xf2bb;
        public const int fa_vcard_o = 0xf2bc;
        public const int fa_venus = 0xf221;
        public const int fa_venus_double = 0xf226;
        public const int fa_venus_mars = 0xf228;
        public const int fa_viacoin = 0xf237;
        public const int fa_viadeo = 0xf2a9;
        public const int fa_viadeo_square = 0xf2aa;
        public const int fa_video_camera = 0xf03d;
        public const int fa_vimeo = 0xf27d;
        public const int fa_vimeo_square = 0xf194;
        public const int fa_vine = 0xf1ca;
        public const int fa_vk = 0xf189;
        public const int fa_volume_control_phone = 0xf2a0;
        public const int fa_volume_down = 0xf027;
        public const int fa_volume_off = 0xf026;
        public const int fa_volume_up = 0xf028;

        public const int fa_warning = 0xf071;
        public const int fa_wechat = 0xf1d7;
        public const int fa_weibo = 0xf18a;
        public const int fa_weixin = 0xf1d7;
        public const int fa_whatsapp = 0xf232;
        public const int fa_wheelchair = 0xf193;
        public const int fa_wheelchair_alt = 0xf29b;
        public const int fa_wifi = 0xf1eb;
        public const int fa_wikipedia_w = 0xf266;
        public const int fa_window_close = 0xf2d3;
        public const int fa_window_close_o = 0xf2d4;
        public const int fa_window_maximize = 0xf2d0;
        public const int fa_window_minimize = 0xf2d1;
        public const int fa_window_restore = 0xf2d2;
        public const int fa_windows = 0xf17a;
        public const int fa_won = 0xf159;
        public const int fa_wordpress = 0xf19a;
        public const int fa_wpbeginner = 0xf297;
        public const int fa_wpexplorer = 0xf2de;
        public const int fa_wpforms = 0xf298;
        public const int fa_wrench = 0xf0ad;

        public const int fa_xing = 0xf168;
        public const int fa_xing_square = 0xf169;

        public const int fa_y_combinator = 0xf23b;
        public const int fa_y_combinator_square = 0xf1d4;
        public const int fa_yahoo = 0xf19e;
        public const int fa_yc = 0xf23b;
        public const int fa_yc_square = 0xf1d4;
        public const int fa_yelp = 0xf1e9;
        public const int fa_yen = 0xf157;
        public const int fa_yoast = 0xf2b1;
        public const int fa_youtube = 0xf167;
        public const int fa_youtube_play = 0xf16a;
        public const int fa_youtube_square = 0xf166;
    }

    /// <summary>
    /// ElegantIcons.ttf V1.0
    /// 33..126, 57344..57609
    /// </summary>
    public static class FontElegantIcons
    {
        public const int arrow_up = 0x21;
        public const int arrow_down = 0x22;
        public const int arrow_left = 0x23;
        public const int arrow_right = 0x24;
        public const int arrow_left_up = 0x25;
        public const int arrow_right_up = 0x26;
        public const int arrow_right_down = 0x27;
        public const int arrow_left_down = 0x28;
        public const int arrow_up_down = 0x29;
        public const int arrow_up_down_alt = 0x2a;
        public const int arrow_left_right_alt = 0x2b;
        public const int arrow_left_right = 0x2c;
        public const int arrow_expand_alt2 = 0x2d;
        public const int arrow_expand_alt = 0x2e;
        public const int arrow_condense = 0x2f;
        public const int arrow_expand = 0x30;
        public const int arrow_move = 0x31;
        public const int arrow_carrot_up = 0x32;
        public const int arrow_carrot_down = 0x33;
        public const int arrow_carrot_left = 0x34;
        public const int arrow_carrot_right = 0x35;
        public const int arrow_carrot_2up = 0x36;
        public const int arrow_carrot_2down = 0x37;
        public const int arrow_carrot_2left = 0x38;
        public const int arrow_carrot_2right = 0x39;
        public const int arrow_carrot_up_alt2 = 0x3a;
        public const int arrow_carrot_down_alt2 = 0x3b;
        public const int arrow_carrot_left_alt2 = 0x3c;
        public const int arrow_carrot_right_alt2 = 0x3d;
        public const int arrow_carrot_2up_alt2 = 0x3e;
        public const int arrow_carrot_2down_alt2 = 0x3f;
        public const int arrow_carrot_2left_alt2 = 0x40;
        public const int arrow_carrot_2right_alt2 = 0x41;
        public const int arrow_triangle_up = 0x42;
        public const int arrow_triangle_down = 0x43;
        public const int arrow_triangle_left = 0x44;
        public const int arrow_triangle_right = 0x45;
        public const int arrow_triangle_up_alt2 = 0x46;
        public const int arrow_triangle_down_alt2 = 0x47;
        public const int arrow_triangle_left_alt2 = 0x48;
        public const int arrow_triangle_right_alt2 = 0x49;
        public const int arrow_back = 0x4a;
        public const int icon_minus_06 = 0x4b;
        public const int icon_plus = 0x4c;
        public const int icon_close = 0x4d;
        public const int icon_check = 0x4e;
        public const int icon_minus_alt2 = 0x4f;
        public const int icon_plus_alt2 = 0x50;
        public const int icon_close_alt2 = 0x51;
        public const int icon_check_alt2 = 0x52;
        public const int icon_zoom_out_alt = 0x53;
        public const int icon_zoom_in_alt = 0x54;
        public const int icon_search = 0x55;
        public const int icon_box_empty = 0x56;
        public const int icon_box_selected = 0x57;
        public const int icon_minus_box = 0x58;
        public const int icon_plus_box = 0x59;
        public const int icon_box_checked = 0x5a;
        public const int icon_circle_empty = 0x5b;
        public const int icon_circle_slelected = 0x5c;
        public const int icon_stop_alt2 = 0x5d;
        public const int icon_stop = 0x5e;
        public const int icon_pause_alt2 = 0x5f;
        public const int icon_pause = 0x60;
        public const int icon_menu = 0x61;
        public const int icon_menu_square_alt2 = 0x62;
        public const int icon_menu_circle_alt2 = 0x63;
        public const int icon_ul = 0x64;
        public const int icon_ol = 0x65;
        public const int icon_adjust_horiz = 0x66;
        public const int icon_adjust_vert = 0x67;
        public const int icon_document_alt = 0x68;
        public const int icon_documents_alt = 0x69;
        public const int icon_pencil = 0x6a;
        public const int icon_pencil_edit_alt = 0x6b;
        public const int icon_pencil_edit = 0x6c;
        public const int icon_folder_alt = 0x6d;
        public const int icon_folder_open_alt = 0x6e;
        public const int icon_folder_add_alt = 0x6f;
        public const int icon_info_alt = 0x70;
        public const int icon_error_oct_alt = 0x71;
        public const int icon_error_circle_alt = 0x72;
        public const int icon_error_triangle_alt = 0x73;
        public const int icon_question_alt2 = 0x74;
        public const int icon_question = 0x75;
        public const int icon_comment_alt = 0x76;
        public const int icon_chat_alt = 0x77;
        public const int icon_vol_mute_alt = 0x78;
        public const int icon_volume_low_alt = 0x79;
        public const int icon_volume_high_alt = 0x7a;
        public const int icon_quotations = 0x7b;
        public const int icon_quotations_alt2 = 0x7c;
        public const int icon_clock_alt = 0x7d;
        public const int icon_lock_alt = 0x7e;
        public const int icon_lock_open_alt = 0xe000;
        public const int icon_key_alt = 0xe001;
        public const int icon_cloud_alt = 0xe002;
        public const int icon_cloud_upload_alt = 0xe003;
        public const int icon_cloud_download_alt = 0xe004;
        public const int icon_image = 0xe005;
        public const int icon_images = 0xe006;
        public const int icon_lightbulb_alt = 0xe007;
        public const int icon_gift_alt = 0xe008;
        public const int icon_house_alt = 0xe009;
        public const int icon_genius = 0xe00a;
        public const int icon_mobile = 0xe00b;
        public const int icon_tablet = 0xe00c;
        public const int icon_laptop = 0xe00d;
        public const int icon_desktop = 0xe00e;
        public const int icon_camera_alt = 0xe00f;
        public const int icon_mail_alt = 0xe010;
        public const int icon_cone_alt = 0xe011;
        public const int icon_ribbon_alt = 0xe012;
        public const int icon_bag_alt = 0xe013;
        public const int icon_creditcard = 0xe014;
        public const int icon_cart_alt = 0xe015;
        public const int icon_paperclip = 0xe016;
        public const int icon_tag_alt = 0xe017;
        public const int icon_tags_alt = 0xe018;
        public const int icon_trash_alt = 0xe019;
        public const int icon_cursor_alt = 0xe01a;
        public const int icon_mic_alt = 0xe01b;
        public const int icon_compass_alt = 0xe01c;
        public const int icon_pin_alt = 0xe01d;
        public const int icon_pushpin_alt = 0xe01e;
        public const int icon_map_alt = 0xe01f;
        public const int icon_drawer_alt = 0xe020;
        public const int icon_toolbox_alt = 0xe021;
        public const int icon_book_alt = 0xe022;
        public const int icon_calendar = 0xe023;
        public const int icon_film = 0xe024;
        public const int icon_table = 0xe025;
        public const int icon_contacts_alt = 0xe026;
        public const int icon_headphones = 0xe027;
        public const int icon_lifesaver = 0xe028;
        public const int icon_piechart = 0xe029;
        public const int icon_refresh = 0xe02a;
        public const int icon_link_alt = 0xe02b;
        public const int icon_link = 0xe02c;
        public const int icon_loading = 0xe02d;
        public const int icon_blocked = 0xe02e;
        public const int icon_archive_alt = 0xe02f;
        public const int icon_heart_alt = 0xe030;
        public const int icon_star_alt = 0xe031;
        public const int icon_star_half_alt = 0xe032;
        public const int icon_star = 0xe033;
        public const int icon_star_half = 0xe034;
        public const int icon_tools = 0xe035;
        public const int icon_tool = 0xe036;
        public const int icon_cog = 0xe037;
        public const int icon_cogs = 0xe038;
        public const int arrow_up_alt = 0xe039;
        public const int arrow_down_alt = 0xe03a;
        public const int arrow_left_alt = 0xe03b;
        public const int arrow_right_alt = 0xe03c;
        public const int arrow_left_up_alt = 0xe03d;
        public const int arrow_right_up_alt = 0xe03e;
        public const int arrow_right_down_alt = 0xe03f;
        public const int arrow_left_down_alt = 0xe040;
        public const int arrow_condense_alt = 0xe041;
        public const int arrow_expand_alt3 = 0xe042;
        public const int arrow_carrot_up_alt = 0xe043;
        public const int arrow_carrot_down_alt = 0xe044;
        public const int arrow_carrot_left_alt = 0xe045;
        public const int arrow_carrot_right_alt = 0xe046;
        public const int arrow_carrot_2up_alt = 0xe047;
        public const int arrow_carrot_2dwnn_alt = 0xe048;
        public const int arrow_carrot_2left_alt = 0xe049;
        public const int arrow_carrot_2right_alt = 0xe04a;
        public const int arrow_triangle_up_alt = 0xe04b;
        public const int arrow_triangle_down_alt = 0xe04c;
        public const int arrow_triangle_left_alt = 0xe04d;
        public const int arrow_triangle_right_alt = 0xe04e;
        public const int icon_minus_alt = 0xe04f;
        public const int icon_plus_alt = 0xe050;
        public const int icon_close_alt = 0xe051;
        public const int icon_check_alt = 0xe052;
        public const int icon_zoom_out = 0xe053;
        public const int icon_zoom_in = 0xe054;
        public const int icon_stop_alt = 0xe055;
        public const int icon_menu_square_alt = 0xe056;
        public const int icon_menu_circle_alt = 0xe057;
        public const int icon_document = 0xe058;
        public const int icon_documents = 0xe059;
        public const int icon_pencil_alt = 0xe05a;
        public const int icon_folder = 0xe05b;
        public const int icon_folder_open = 0xe05c;
        public const int icon_folder_add = 0xe05d;
        public const int icon_folder_upload = 0xe05e;
        public const int icon_folder_download = 0xe05f;
        public const int icon_info = 0xe060;
        public const int icon_error_circle = 0xe061;
        public const int icon_error_oct = 0xe062;
        public const int icon_error_triangle = 0xe063;
        public const int icon_question_alt = 0xe064;
        public const int icon_comment = 0xe065;
        public const int icon_chat = 0xe066;
        public const int icon_vol_mute = 0xe067;
        public const int icon_volume_low = 0xe068;
        public const int icon_volume_high = 0xe069;
        public const int icon_quotations_alt = 0xe06a;
        public const int icon_clock = 0xe06b;
        public const int icon_lock = 0xe06c;
        public const int icon_lock_open = 0xe06d;
        public const int icon_key = 0xe06e;
        public const int icon_cloud = 0xe06f;
        public const int icon_cloud_upload = 0xe070;
        public const int icon_cloud_download = 0xe071;
        public const int icon_lightbulb = 0xe072;
        public const int icon_gift = 0xe073;
        public const int icon_house = 0xe074;
        public const int icon_camera = 0xe075;
        public const int icon_mail = 0xe076;
        public const int icon_cone = 0xe077;
        public const int icon_ribbon = 0xe078;
        public const int icon_bag = 0xe079;
        public const int icon_cart = 0xe07a;
        public const int icon_tag = 0xe07b;
        public const int icon_tags = 0xe07c;
        public const int icon_trash = 0xe07d;
        public const int icon_cursor = 0xe07e;
        public const int icon_mic = 0xe07f;
        public const int icon_compass = 0xe080;
        public const int icon_pin = 0xe081;
        public const int icon_pushpin = 0xe082;
        public const int icon_map = 0xe083;
        public const int icon_drawer = 0xe084;
        public const int icon_toolbox = 0xe085;
        public const int icon_book = 0xe086;
        public const int icon_contacts = 0xe087;
        public const int icon_archive = 0xe088;
        public const int icon_heart = 0xe089;
        public const int icon_profile = 0xe08a;
        public const int icon_group = 0xe08b;
        public const int icon_grid_2x2 = 0xe08c;
        public const int icon_grid_3x3 = 0xe08d;
        public const int icon_music = 0xe08e;
        public const int icon_pause_alt = 0xe08f;
        public const int icon_phone = 0xe090;
        public const int icon_upload = 0xe091;
        public const int icon_download = 0xe092;
        public const int social_facebook = 0xe093;
        public const int social_twitter = 0xe094;
        public const int social_pinterest = 0xe095;
        public const int social_googleplus = 0xe096;
        public const int social_tumblr = 0xe097;
        public const int social_tumbleupon = 0xe098;
        public const int social_wordpress = 0xe099;
        public const int social_instagram = 0xe09a;
        public const int social_dribbble = 0xe09b;
        public const int social_vimeo = 0xe09c;
        public const int social_linkedin = 0xe09d;
        public const int social_rss = 0xe09e;
        public const int social_deviantart = 0xe09f;
        public const int social_share = 0xe0a0;
        public const int social_myspace = 0xe0a1;
        public const int social_skype = 0xe0a2;
        public const int social_youtube = 0xe0a3;
        public const int social_picassa = 0xe0a4;
        public const int social_googledrive = 0xe0a5;
        public const int social_flickr = 0xe0a6;
        public const int social_blogger = 0xe0a7;
        public const int social_spotify = 0xe0a8;
        public const int social_delicious = 0xe0a9;
        public const int social_facebook_circle = 0xe0aa;
        public const int social_twitter_circle = 0xe0ab;
        public const int social_pinterest_circle = 0xe0ac;
        public const int social_googleplus_circle = 0xe0ad;
        public const int social_tumblr_circle = 0xe0ae;
        public const int social_stumbleupon_circle = 0xe0af;
        public const int social_wordpress_circle = 0xe0b0;
        public const int social_instagram_circle = 0xe0b1;
        public const int social_dribbble_circle = 0xe0b2;
        public const int social_vimeo_circle = 0xe0b3;
        public const int social_linkedin_circle = 0xe0b4;
        public const int social_rss_circle = 0xe0b5;
        public const int social_deviantart_circle = 0xe0b6;
        public const int social_share_circle = 0xe0b7;
        public const int social_myspace_circle = 0xe0b8;
        public const int social_skype_circle = 0xe0b9;
        public const int social_youtube_circle = 0xe0ba;
        public const int social_picassa_circle = 0xe0bb;
        public const int social_googledrive_alt2 = 0xe0bc;
        public const int social_flickr_circle = 0xe0bd;
        public const int social_blogger_circle = 0xe0be;
        public const int social_spotify_circle = 0xe0bf;
        public const int social_delicious_circle = 0xe0c0;
        public const int social_facebook_square = 0xe0c1;
        public const int social_twitter_square = 0xe0c2;
        public const int social_pinterest_square = 0xe0c3;
        public const int social_googleplus_square = 0xe0c4;
        public const int social_tumblr_square = 0xe0c5;
        public const int social_stumbleupon_square = 0xe0c6;
        public const int social_wordpress_square = 0xe0c7;
        public const int social_instagram_square = 0xe0c8;
        public const int social_dribbble_square = 0xe0c9;
        public const int social_vimeo_square = 0xe0ca;
        public const int social_linkedin_square = 0xe0cb;
        public const int social_rss_square = 0xe0cc;
        public const int social_deviantart_square = 0xe0cd;
        public const int social_share_square = 0xe0ce;
        public const int social_myspace_square = 0xe0cf;
        public const int social_skype_square = 0xe0d0;
        public const int social_youtube_square = 0xe0d1;
        public const int social_picassa_square = 0xe0d2;
        public const int social_googledrive_square = 0xe0d3;
        public const int social_flickr_square = 0xe0d4;
        public const int social_blogger_square = 0xe0d5;
        public const int social_spotify_square = 0xe0d6;
        public const int social_delicious_square = 0xe0d7;
        public const int icon_printer = 0xe103;
        public const int icon_calulator = 0xe0ee;
        public const int icon_building = 0xe0ef;
        public const int icon_floppy = 0xe0e8;
        public const int icon_drive = 0xe0ea;
        public const int icon_search_2 = 0xe101;
        public const int icon_id = 0xe107;
        public const int icon_id_2 = 0xe108;
        public const int icon_puzzle = 0xe102;
        public const int icon_like = 0xe106;
        public const int icon_dislike = 0xe0eb;
        public const int icon_mug = 0xe105;
        public const int icon_currency = 0xe0ed;
        public const int icon_wallet = 0xe100;
        public const int icon_pens = 0xe104;
        public const int icon_easel = 0xe0e9;
        public const int icon_flowchart = 0xe109;
        public const int icon_datareport = 0xe0ec;
        public const int icon_briefcase = 0xe0fe;
        public const int icon_shield = 0xe0f6;
        public const int icon_percent = 0xe0fb;
        public const int icon_globe = 0xe0e2;
        public const int icon_globe_2 = 0xe0e3;
        public const int icon_target = 0xe0f5;
        public const int icon_hourglass = 0xe0e1;
        public const int icon_balance = 0xe0ff;
        public const int icon_rook = 0xe0f8;
        public const int icon_printer_alt = 0xe0fa;
        public const int icon_calculator_alt = 0xe0e7;
        public const int icon_building_alt = 0xe0fd;
        public const int icon_floppy_alt = 0xe0e4;
        public const int icon_drive_alt = 0xe0e5;
        public const int icon_search_alt = 0xe0f7;
        public const int icon_id_alt = 0xe0e0;
        public const int icon_id_2_alt = 0xe0fc;
        public const int icon_puzzle_alt = 0xe0f9;
        public const int icon_like_alt = 0xe0dd;
        public const int icon_dislike_alt = 0xe0f1;
        public const int icon_mug_alt = 0xe0dc;
        public const int icon_currency_alt = 0xe0f3;
        public const int icon_wallet_alt = 0xe0d8;
        public const int icon_pens_alt = 0xe0db;
        public const int icon_easel_alt = 0xe0f0;
        public const int icon_flowchart_alt = 0xe0df;
        public const int icon_datareport_alt = 0xe0f2;
        public const int icon_briefcase_alt = 0xe0f4;
        public const int icon_shield_alt = 0xe0d9;
        public const int icon_percent_alt = 0xe0da;
        public const int icon_globe_alt = 0xe0de;
        public const int icon_clipboard = 0xe0e6;
    }
}
